`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/25 21:55:51
// Design Name: 
// Module Name: buzzer_ctl
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module buzzer_ctl(
    input clk,
    input rst,
    input switch,
    input [8:0] last_change,
    input [511:0] key_down,
    input Caps,
    output reg [3:0] sound1,
    output reg [3:0] sound2,
    output reg [15:0] audio_left,
    output reg [15:0] audio_right
    );
    reg [21:0] freq_gen_1;
    reg [21:0] freq_gen_2;
    reg [21:0] cnt1;
    reg [21:0] cnt2;
    reg [21:0] cnt1_tmp;
    reg [21:0] cnt2_tmp;
    reg toggle1;
    reg toggle2;
    reg toggle1_tmp;
    reg toggle2_tmp;
    
    always@*
    if(key_down[last_change])
        if(~switch)
            case(last_change)
            9'h21: // c
                if(Caps) begin 
                    sound1 = 4'd0;
                    sound2 = 4'd0;
                    freq_gen_1 = 22'd95602;
                    freq_gen_2 = 22'd95602;
                end
                else begin
                    sound1 = 4'd1;
                    sound2 = 4'd1;
                    freq_gen_1 = 22'd191571;
                    freq_gen_2 = 22'd191571;
                end
            9'h23: // d
                if(Caps) begin
                    sound1 = 4'd2;
                    sound2 = 4'd2;
                    freq_gen_1 = 22'd85179;
                    freq_gen_2 = 22'd85179;
                end
                else begin
                    sound1 = 4'd3;
                    sound2 = 4'd3;
                    freq_gen_1 = 22'd170648;
                    freq_gen_2 = 22'd170648;
                end
            9'h24: // e
                if(Caps) begin
                    sound1 = 4'd4;
                    sound2 = 4'd4;
                    freq_gen_1 = 22'd75872;
                    freq_gen_2 = 22'd75872;
                end
                else begin
                    sound1 = 4'd5;
                    sound2 = 4'd5;
                    freq_gen_1 = 22'd151515;
                    freq_gen_2 = 22'd151515;
                end
            9'h2B: // f
                if(Caps) begin
                    sound1 = 4'd6;
                    sound2 = 4'd6;
                    freq_gen_1 = 22'd71633;
                    freq_gen_2 = 22'd71633;
                end
                else begin
                    sound1 = 4'd7;
                    sound2 = 4'd7;
                    freq_gen_1 = 22'd143266;
                    freq_gen_2 = 22'd143266;
                end
            9'h34: // g
                if(Caps) begin
                    sound1 = 4'd8;
                    sound2 = 4'd8;
                    freq_gen_1 = 22'd63775;
                    freq_gen_2 = 22'd63775;
                end
                else begin
                    sound1 = 4'd9;
                    sound2 = 4'd9;
                    freq_gen_1 = 22'd127551;
                    freq_gen_2 = 22'd127551;
                end
            9'h1C: //a
                if(Caps) begin
                    sound1 = 4'd10;
                    sound2 = 4'd10;
                    freq_gen_1 = 22'd56818;
                    freq_gen_2 = 22'd56818;
                end
                else begin
                    sound1 = 4'd11;
                    sound2 = 4'd11;
                    freq_gen_1 = 22'd113636;
                    freq_gen_2 = 22'd113636;
                end
            9'h32: // b
                if(Caps) begin
                    sound1 = 4'd12;
                    sound2 = 4'd12;
                    freq_gen_1 = 22'd50607;
                    freq_gen_2 = 22'd50607;
                end
                else begin
                    sound1 = 4'd13;
                    sound2 = 4'd13;
                    freq_gen_1 = 22'd101214;
                    freq_gen_2 = 22'd101214;
                end
            default: begin
                sound1 = 4'd14;
                sound2 = 4'd14;
                freq_gen_1 = 22'd0;
                freq_gen_2 = 22'd0;
            end
        endcase
        else
            case(last_change)
            9'h21: // c,e
                if(Caps) begin 
                    sound1 = 4'd0;
                    sound2 = 4'd4;
                    freq_gen_1 = 22'd95602;
                    freq_gen_2 = 22'd75872;
                end
                else begin
                    sound1 = 4'd1;
                    sound2 = 4'd5;
                    freq_gen_1 = 22'd191571;
                    freq_gen_2 = 22'd151515;
                end
            9'h23: // d,f
                if(Caps) begin
                    sound1 = 4'd2;
                    sound2 = 4'd6;;
                    freq_gen_1 = 22'd85179;
                    freq_gen_2 = 22'd71633;
                end
                else begin
                    sound1 = 4'd3;
                    sound2 = 4'd7;
                    freq_gen_1 = 22'd170648;
                    freq_gen_2 = 22'd143266;
                end
            9'h24: // e,g
                if(Caps) begin
                    sound1 = 4'd4;
                    sound2 = 4'd8;
                    freq_gen_1 = 22'd75872;
                    freq_gen_2 = 22'd63775;
                end
                else begin
                    sound1 = 4'd5;
                    sound2 = 4'd9;
                    freq_gen_1 = 22'd151515;
                    freq_gen_2 = 22'd127551;
                end
            9'h2B: // f,a
                if(Caps) begin
                    sound1 = 4'd6;
                    sound2 = 4'd10;
                    freq_gen_1 = 22'd71633;
                    freq_gen_2 = 22'd56818;
                end
                else begin
                    sound1 = 4'd7;
                    sound2 = 4'd11;
                    freq_gen_1 = 22'd143266;
                    freq_gen_2 = 22'd113636;
                end
            9'h34: // g,b
                if(Caps) begin
                    sound1 = 4'd8;
                    sound2 = 4'd12;
                    freq_gen_1 = 22'd63775;
                    freq_gen_2 = 22'd50607;
                end
                else begin
                    sound1 = 4'd9;
                    sound2 = 4'd13;
                    freq_gen_1 = 22'd127551;
                    freq_gen_2 = 22'd101214;
                end
            default: begin
                sound1 = 4'd14;
                sound2 = 4'd14;
                freq_gen_1 = 22'd0;
                freq_gen_2 = 22'd0;
            end
        endcase
    else begin
        sound1 = 4'd14;
        sound2 = 4'd14;
        freq_gen_1 = 22'd0;
        freq_gen_2 = 22'd0;
    end
    
    always@*
    if(cnt1 == freq_gen_1)
    begin
        cnt1_tmp = 22'd0;
        toggle1_tmp = ~toggle1;
    end
    else
    begin
        cnt1_tmp = cnt1 + 1'b1;
        toggle1_tmp = toggle1;
    end

    always@*
    if(cnt2 == freq_gen_2)
    begin
        cnt2_tmp = 22'd0;
        toggle2_tmp = ~toggle2;
    end
    else
    begin
        cnt2_tmp = cnt2 + 1'b1;
        toggle2_tmp = toggle2;
    end
    
    always@(posedge clk or posedge rst)
    if(rst)
    begin
        cnt1 <= 22'd0;
        cnt2 <= 22'd0;
        toggle1 <= 1'b0;
        toggle2 <= 1'b0;
    end
    else
    begin
        cnt1 <= cnt1_tmp;
        cnt2 <= cnt2_tmp;
        toggle1 <= toggle1_tmp;
        toggle2 <= toggle2_tmp;
    end
    
    always@*
    if(toggle1)
        audio_left = 16'h4111;
    else
        audio_left = 16'h2000;
        
    always@*
    if(toggle2)
        audio_right = 16'h4111;
    else
        audio_right = 16'h2000;

endmodule
