`define SS_d 8'b10000101
`define SS_o 8'b11000101
`define SS_r 8'b11110101
`define SS_E 8'b01100001
`define SS_m 8'b11010101
`define SS_i 8'b11011111
`define SS_F 8'b01110001
`define SS_A 8'b00010001
`define SS_S 8'b01001001
`define SS_L 8'b11100011

module decoder(
    input [3:0] sound1,
    input [3:0] sound2,
    output reg [7:0] D1,
    output reg [7:0] D2,
    output reg [7:0] D3,
    output reg [7:0] D4
    );
    
    always@*
        case({sound1,sound2})
        8'h00: begin 
            D1 = `SS_o;
            D2 = `SS_d;
            D3 = `SS_o;
            D4 = `SS_d;
        end
        8'h11: begin 
            D1 = `SS_o;
            D2 = `SS_d;
            D3 = `SS_o;
            D4 = `SS_d;
        end
        8'h22: begin 
            D1 = `SS_E;
            D2 = `SS_r;
            D3 = `SS_E;
            D4 = `SS_r;
        end
        8'h33: begin 
            D1 = `SS_E;
            D2 = `SS_r;
            D3 = `SS_E;
            D4 = `SS_r;
        end
        8'h44: begin 
            D1 = `SS_i;
            D2 = `SS_m;
            D3 = `SS_i;
            D4 = `SS_m;
        end
        8'h55: begin 
            D1 = `SS_i;
            D2 = `SS_m;
            D3 = `SS_i;
            D4 = `SS_m;
        end
        8'h66: begin 
            D1 = `SS_A;
            D2 = `SS_F;
            D3 = `SS_A;
            D4 = `SS_F;
        end
        8'h77: begin 
            D1 = `SS_A;
            D2 = `SS_F;
            D3 = `SS_A;
            D4 = `SS_F;
        end
        8'h88: begin 
            D1 = `SS_o;
            D2 = `SS_S;
            D3 = `SS_o;
            D4 = `SS_S;
        end
        8'h99: begin 
            D1 = `SS_o;
            D2 = `SS_S;
            D3 = `SS_o;
            D4 = `SS_S;
        end
        8'hAA: begin 
            D1 = `SS_A;
            D2 = `SS_L;
            D3 = `SS_A;
            D4 = `SS_L;
        end
        8'hBB: begin 
            D1 = `SS_A;
            D2 = `SS_L;
            D3 = `SS_A;
            D4 = `SS_L;
        end
        8'hCC: begin 
            D1 = `SS_i;
            D2 = `SS_S;
            D3 = `SS_i;
            D4 = `SS_S;
        end
        8'hDD: begin 
            D1 = `SS_i;
            D2 = `SS_S;
            D3 = `SS_i;
            D4 = `SS_S;
        end
        8'h04: begin 
            D1 = `SS_i;
            D2 = `SS_m;
            D3 = `SS_o;
            D4 = `SS_d;
        end
        8'h15: begin 
            D1 = `SS_i;
            D2 = `SS_m;
            D3 = `SS_o;
            D4 = `SS_d;
        end
        8'h26: begin 
            D1 = `SS_A;
            D2 = `SS_F;
            D3 = `SS_E;
            D4 = `SS_r;
        end
        8'h37: begin 
            D1 = `SS_A;
            D2 = `SS_F;
            D3 = `SS_E;
            D4 = `SS_r;
        end
        8'h48: begin 
            D1 = `SS_o;
            D2 = `SS_S;
            D3 = `SS_i;
            D4 = `SS_m;
        end
        8'h59: begin 
            D1 = `SS_o;
            D2 = `SS_S;
            D3 = `SS_i;
            D4 = `SS_m;
        end
        8'h6A: begin 
            D1 = `SS_A;
            D2 = `SS_L;
            D3 = `SS_A;
            D4 = `SS_F;
        end
        8'h7B: begin 
            D1 = `SS_A;
            D2 = `SS_L;
            D3 = `SS_A;
            D4 = `SS_F;
        end
        8'h8C: begin 
            D1 = `SS_i;
            D2 = `SS_S;
            D3 = `SS_o;
            D4 = `SS_S;
        end
        8'h9D: begin 
            D1 = `SS_i;
            D2 = `SS_S;
            D3 = `SS_o;
            D4 = `SS_S;
        end
        8'hEE: begin 
            D1 = 8'b11111101;
            D2 = 8'b11111101;
            D3 = 8'b11111101;
            D4 = 8'b11111101;
        end
        default: begin
            D1 = 8'b00000000;
            D2 = 8'b00000000;
            D3 = 8'b00000000;
            D4 = 8'b00000000;
        end
        endcase
        
endmodule