module scan_ctl(
    output reg [3:0] ssd_ctl,
    output reg [7:0] segs,
    input clk,
    input rst,
    input [7:0] letter1,
    input [7:0] letter2,
    input [7:0] letter3,
    input [7:0] letter4
    );
    reg [11:0] cnt;
    reg [13:0] cnt_tmp;
    reg [1:0] scan_ctl;
    
    always@*
    cnt_tmp = {scan_ctl,cnt} + 1'b1;
    
    always@(posedge clk or posedge rst)
    if(rst)
        {scan_ctl,cnt} <= 14'd0;
    else
        {scan_ctl,cnt} <= cnt_tmp;
        
    always@*
    case(scan_ctl)
        2'b00:
        begin
            ssd_ctl = 4'b1110;
            segs = letter1;
        end
        2'b01:
        begin
            ssd_ctl = 4'b1101;
            segs = letter2;
        end
        2'b10:
        begin
            ssd_ctl = 4'b1011;
            segs = letter3;
        end
        2'b11:
        begin
            ssd_ctl = 4'b0111;
            segs = letter4;
        end
        default:
        begin
            ssd_ctl=4'b0000;
            segs = letter1;
        end
    endcase
    
endmodule
