module top_module(
    input clk,
    input rst,
    input switch,
    inout PS2_DATA,
    inout PS2_CLK,
    output audio_mclk,
    output audio_lrck,
    output audio_sck,
    output audio_sdin,
    output [3:0] ssd_ctl,
    output [7:0] segs,
    output reg LED
    );
    wire [8:0] last_change;
    wire key_valid;
    wire [511:0] key_down;
    wire press;
    wire Caps;
    wire [3:0] sound1;
    wire [3:0] sound2;
    wire [15:0] audio_left;
    wire [15:0] audio_right;
    wire [7:0] letter1;
    wire [7:0] letter2;
    wire [7:0] letter3;
    wire [7:0] letter4;
        
    KeyboardDecoder U0(.clk(clk),.rst(rst),.PS2_DATA(PS2_DATA),.PS2_CLK(PS2_CLK)
                        ,.last_change(last_change),.key_down(key_down),.key_valid(key_valid));
    CAPS_state U1(.clk(clk),.rst(rst),.last_change(last_change),.key_down(key_down),.Caps(Caps));
    buzzer_ctl U2(.clk(clk),.rst(rst),.switch(switch),.last_change(last_change),.key_down(key_down),.Caps(Caps)
                    ,.sound1(sound1),.sound2(sound2),.audio_left(audio_left),.audio_right(audio_right));
    speaker_ctl U3(.clk(clk),.rst(rst),.audio_in_left(audio_left),.audio_in_right(audio_right)
                    ,.audio_mclk(audio_mclk),.audio_lrck(audio_lrck),.audio_sck(audio_sck),.audio_sdin(audio_sdin));
    decoder U4(.sound1(sound1),.sound2(sound2),.D1(letter1),.D2(letter2),.D3(letter3),.D4(letter4));
    scan_ctl U5(.clk(clk),.rst(rst),.letter1(letter1),.letter2(letter2),.letter3(letter3)
                ,.letter4(letter4),.ssd_ctl(ssd_ctl),.segs(segs));
    
    always@*
    if(Caps)
        LED = 1'b1;
    else
        LED = 1'b0;
    
endmodule